/* Création d'une bibliothèque pour le TP */

LIBNAME folderTP '/home/clemlesech0';

**************************************;
/* EXERCICE 1 : Les dépenses à Noël */
**************************************;

/* Question 1 - Import du jeu de données */

DATA folderTP.depense;
	INFILE '/home/clemlesech0/depense.txt' DLM=' ' FIRSTOBS=2;
	INPUT id taille depense csp$ pratiquant$;
RUN;

/*Supprimer colonne ID*/	
DATA folderTP.depense;
	SET folderTP.depense;
	DROP id;
RUN;
	
/*Question 2 - Description des variables */
PROC DATASETS;
	CONTENTS DATA=folderTP.depense;
RUN;

*Pour connaître le nombre de modalités;
PROC FREQ DATA=folderTP.depense;
	TABLES csp pratiquant;
RUN;

/* Question 3 - La dépense moyenne à Noël chez les familles pratiquantes est-elle 
significativement plus élevée que chez les familles non pratiquantes ? */

	
	/* a) Présentation graphique des variables 'depense' et 'pratiquant' */

*Il faut d'abord trier le dataset;
PROC SORT data=folderTP.depense;
	BY pratiquant;
RUN;

* Boxplot entre depense et pratiquant;
PROC BOXPLOT data = folderTP.depense;
	PLOT depense*pratiquant; 
RUN;

* --> Graphiquement, il semble que les moyennes entre les familles pratiquantes et non pratiquantes sont égales (autour de 400 euros); 


	/* b) Quel test semble le plus adapté pour répondre à la question ? */

* --> Comparaison des moyennes grâce au test de Student pour échantillons indépendants ;


	/* c) Quelles sont les hypothèses de ce test ? */
	
*	H0: mu(pratiquant) = mu(non pratiquant)
	H1: mu(pratiquant) >  mu(non pratiquant);

	
	/* d) Vérification des conditions */
	
* Vérification de la normalité de l'échantillon ;
ODS SELECT TestsforNormality; *Pour afficher seulement le tableau 'TestsforNormality';
PROC UNIVARIATE DATA=folderTP.depense NORMAL;
	VAR depense;
	BY pratiquant;
RUN;

* --> Les pvalues sont supérieurs à 0.05 : non rejet de H0. Les  ;

PROC TABULATE DATA=folderTP.depense;
	CLASS pratiquant;
	VAR depense;
	TABLE pratiquant,depense * (sum mean n);
RUN;
	
/*Les échantillons sont >=30. On peut appliquer le test de student. */

	/* e) Réaliser le test de student qui fournit aussi l'égalité des variances entre autre. */

*Trie du jeu de données ;
PROC SORT data=folderTP.depense;
BY pratiquant;
RUN;

PROC TTEST data = folderTP.depense side=U; * test unilatéral ;
	VAR depense;
	CLASS pratiquant;
RUN;

*Test d'égalité des variances :
H0 : les variances sont homogènes
H1 : les variances ne sont pas homogènes;
* pvalue = 0.2243 > 0.05 : non rejet de H0 --> les variances sont homogènes.

*Test de comparaison des moyennes :
* p-value = 0.5475 > 0.05 : non rejet de H0 
-- > A Noël, les familles pratiquantes ne dépensent pas plus que les familles non pratiquantes.;

/* Question 4 - Lien entre la taille de la famille et les dépenses à Noël */

	/* a) Représentation graphique */
	
PROC GPLOT DATA = folderTP.depense ;
	PLOT depense * taille;
RUN ;

 	/* b) Test statistique adapté */
 	
* Les deux variables sont quantitatives. On souhaite savoir s'il existe un lien
entre ces variables --> test de Corrélation de Pearson. ;


	/* c) Les hypothèses */

* H0: les variables sont indépendantes
  H1: les variables sont dépendantes ;

	/* d) Test */
	
PROC CORR DATA=folderTP.depense;
	VAR taille;
	WITH depense;
RUN;

* Coefficient = -0.62209 -- > Corrélation négative modérée  ;
* Pvalue < 0.05 : il existe un lien négatif entre la taille de la famille et les dépenses à Noël ;


/*Question 5 - Lien entre CSP et la pratique de la religion */

	/* a) Graphique entre deux variables qualitatives */
	
PROC GCHART data = folderTP.depense;
	VBAR csp / DISCRETE SUBGROUP = pratiquant;
RUN;

	/* b) Tableau de contingence */
PROC FREQ DATA=folderTP.depense;
	TABLES csp pratiquant csp*pratiquant / nopercent norow nocol;
RUN;
	
	/*c) Tableau des effectifs théoriques*/
PROC FREQ DATA=folderTP.depense;
	TABLES csp*pratiquant / nopercent norow nocol expected;
RUN;

	/*d) Test le plus adapté */
	
* Les deux variables sont qualitatives. On souhaite savoir s'il existe un lien
entre ces variables --> test du Khi Deux ;

	/*e) Les conditions d'application */

*Il faut que les effectifs théoriques soient suppérieurs à 5. C'est le cas ici.
--> le test du khi deux est réalisable.;

	/*f) Les hypothèses */

* H0: les variables sont indépendantes
  H1: les variables sont dépendantes ;
  
  	/*g) Le test */

PROC FREQ DATA=folderTP.depense;
	TABLES csp*pratiquant / chisq;
RUN;

* pvalue=0.3983 > 0.05 : non rejet de H0. Les variables sont indépendantes.
--> Il n'existe pas de lien entre la CSP et le fait d'être pratiquant ou non.;

*********************************************;
/*EXERCICE 2 - LA VO2MAX CHEZ LES CYCLISTES */
*********************************************;

/*Question 1 et 2 - Création du jeu de données et d'une nouvelle variable */
DATA folderTP.VO2max;
	INPUT coureur$ A2015 A2016;
	diff_2015_2016 = A2016-A2015;
	CARDS;
	C1 68 69
	C2 60 65
	C3 74 70
	C4 68 69
	C5 67 73
	C6 74 72
	C7 70 69
	C8 63 72
	C9 74 65
	C10 71 74
	;
	RUN;

/*Question 3 - Histogramme */
PROC GCHART data = folderTP.VO2max;
	VBAR diff_2015_2016;
RUN;

/*Question 4 - Test de conformité */

* H0 : mu(diff_2015_2016)=0
  H1 : mu(diff_2015_2016)>0 ; 
  
PROC TTEST data = folderTP.VO2max side=U;
	VAR diff_2015_2016;
RUN;
	
/*On voit que la p-value=0.3000 > 0.05 : non rejet de H0. 
--> Les VO2Max n'ont pas augmenté d'une année à l'autre. */


/*Question 5 - Représentation graphique */
PROC GCHART data = folderTP.VO2max;
	VBAR A2015 A2016;
RUN;
	
/*Question 6 - Hypothèses de test */

* H0 : mu(VO2MAX_2016) = mu(VO2MAX_2015)
  H1 : mu(VO2MAX_2016) > mu(VO2MAX_2015) ;
  
/*Question 7 - Conditions d'application */

ODS SELECT TestsforNormality; *Pour afficher seulement le tableau 'TestsforNormality';
PROC UNIVARIATE data = folderTP.VO2max NORMAL;
	VAR A2015 A2016;
RUN;

* --> les variables suivent une loi normale ;

/*Question 8 - Test de Student pour échantillon appariés */
PROC TTEST DATA=folderTP.VO2max SIDE = U;
      PAIRED A2016*A2015;
RUN;

/*Nous avons donc la même p-value. 
Cependant, cette technique est mieux car on ne créé pas de nouvelles variables.*/



*************************************;
/*EXERCICE 3 - Le poids des poulets */
*************************************;

FILENAME donnees "/home/clemlesech0/chickwts.txt" ENCODING="utf-8";

/* Queqtion 1 - Import du fichier */
PROC IMPORT datafile = donnees
    out = folderTP.donnees
    dbms=dlm
    replace;
    getnames=yes;
    delimiter=";";
RUN;

/*Supprimer colonne ID*/	
DATA folderTP.donnees;
	SET folderTP.donnees;
	DROP id;
RUN;

/* Question 2 - Existe-t-il un lien entre le poids et le complément alimentaire donné ?*/

	/* a) Le nombre d'individus par groupe */

/*Trie du jeu de données */
PROC SORT data=folderTP.donnees;
BY feed;
RUN;

PROC FREQ data=folderTP.donnees;
TABLES feed;
RUN;

	/* b) Représentation graphique des données */
PROC BOXPLOT data= folderTP.donnees;
PLOT weight*feed;
RUN;

* Graphiquement, il semble qu'il y a un lien entre le poids moyen et le complément alimentaire. ;

	/* c) Test */

* On veut savoir si il existe un lien entre le poids et le complément alimentaire :
Soit un lien entre une variable quantitative et une variable qualitative à k modalités.
--> le test adapté est donc un test de l'ANOVA ;

	/* d) Hypothèses de test */

* H0 : mu(casein) = mu(horsebean)= mu(linseed) = mu(meatmeal) = mu(soybean) = mu(sunflower);
* H1 : au moins une des moyennes est différente ;

	/* e) Vérification des conditions */

* 1ère condition : échantillons grands ou gaussiens pour chaque modalités ;

* - n<30, donc on vérifie la normalité;
* Hypothèses:
- H0 : la variable suit une loi normale
- H1 : la variable ne suit pas une loi normale;

ODS SELECT TestsforNormality; 
PROC UNIVARIATE NORMAL PLOT data=folderTP.donnees;
VAR weight;
BY feed;
RUN;

* cassein : non rejet de H0 -> gaussien ;
* horsebean : non rejet de H0 -> gaussien ; 
* linseed : non rejet de H0 -> gaussien ;
* meatmeal : non rejet de H0 -> gaussien ;
* soybean : non rejet de H0 -> gaussien ;
* sunflower : non rejet de H0 -> gaussien ;

* ---> 1ère condition respectée ;

* 2ème condition : variances homogènes ;
* Hypothèses:
- H0 : les variances sont homogènes
- H1 : les variances ne sont pas homogènes;

PROC GLM DATA=folderTP.donnees;
CLASS feed;
MODEL weight=feed;
MEANS feed / HOVTEST=levene(type=abs) WELCH;
OUTPUT OUT=res R=residus P=predites;
RUN;

* Test de levene, pvalue = 0.4324 - non rejet de H0 : les variances sont homogènes;

* vérification de la normalité des résidus ;
PROC UNIVARIATE NORMAL PLOT DATA=res;
VAR residus;
RUN;
* --> gaussien ;

	/* f) Test ANOVA */
* Le test est réalisé avec la PROC GLM présentée ci-dessus.
La pvalue du test est inférieure à 5% : l'hypothèse H0 est rejetée.

---> Il existe au moins une moyenne significativement différente. 
---> Il y a un lien entre le poid et le complément alimentaire donné ;


**********************************************;
/*EXERCICE 4 - LE TEMPS PASSE DEVANT LA TELE */
**********************************************;

FILENAME fichier "/home/clemlesech0/temps.csv" ENCODING="utf-8";

PROC IMPORT DATAFILE= fichier
	OUT= folderTP.temps
	DBMS=csv
	REPLACE;
    DELIMITER=",";
	GETNAMES=yes;
RUN;

* Recoder les modalités ;
* 1 : homme, 2 : femme;

* A : A - moins de 20 ans;
* B : B - 20-30 ans ;
* C : C - 30-40 ans;
* D : D - 40-60 ans;
* E : E - plus de 60 ans;


DATA folderTP.TEMPS;
	LENGTH recode_periode $ 15;
	SET folderTP.TEMPS;
	SELECT (periode);
		WHEN ('A') recode_periode='A - moins de 20 ans';
		WHEN ('B') recode_periode='B - 20-30 ans';
		WHEN ('C') recode_periode='C - 30-40 ans';
		WHEN ('D') recode_periode='D - 40-60 ans';
		WHEN ('E') recode_periode='E - plus de 60 ans';
		OTHERWISE recode_periode=periode;
	END;
RUN;


DATA folderTP.TEMPS;
	LENGTH recode_sexe $ 15;
	SET folderTP.TEMPS;
	SELECT (sexe);
		WHEN ('1') recode_sexe='Homme';
		WHEN ('2') recode_sexe='Femme';
		OTHERWISE recode_sexe=sexe;
	END;
RUN;

* Supression des variables codées *;
DATA folderTP.TEMPS;
	SET folderTP.TEMPS;
	DROP sexe periode;
RUN;

* Renom des variables recodées *;
DATA folderTP.TEMPS;
	SET folderTP.TEMPS (RENAME=(recode_sexe=sexe recode_periode=periode));
RUN;

/* ANOVA à deux facteurs */
*--------------------------------------------------------------------------;
* Le genre et l'âge influent-t-ils sur le temps passé à regarder la télé ?;


* Description des données ;

* Il faut d'abord trier le jeu de données selon le sexe et la période;
PROC SORT data=folderTP.temps;
	BY sexe periode ;
RUN;

/* On observe le nb d'observations, les moyennes et les écarts types 
selon chaque combinaison sexe*periode */
PROC MEANS DATA=folderTP.temps MAXDEC=2 N MEAN STD;
	TITLE 'Statistiques';
	BY sexe periode;
	VAR temps;
OUTPUT OUT=folderTP.moyenne MEAN=Moyenne;

*Représentation graphique ;
PROC PLOT DATA=folderTP.moyenne ;
   TITLE 'Représentation graphique';
   PLOT Moyenne*sexe$ periode;
RUN;

* --> on peut observer graphiquement que le temps moyen passé devant la télé est plus
élevé chez les femmes de plus de 60 ans, et plus faible chez les femmes 
qui ont entre 30 et 40 ans;

* Vérification des conditions d'application ;
* - Normalité des résidus 
Hypothèses : 
H0 : les résidus suivent une loi normale
H1 : les résidus ne suivent pas une loi normale ;


PROC GLM DATA=folderTP.temps NOPRINT;
   TITLE 'Vérification de la normalité des résidus';
   CLASS sexe periode;
   MODEL temps = sexe | periode;
   OUTPUT OUT= folderTP.residus R=residus;
RUN;

ODS SELECT TestsforNormality;
PROC UNIVARIATE DATA=folderTP.residus PLOT NORMAL;
	TITLE 'Vérification de la normalité des résidus';
	VAR residus;
RUN;

* pvalue > 0.05 
--> Non rejet de H0 : les résidus suivent une loi normale
Hypothèse de test vérifiée ;

** Test de l'ANOVA à deux facteurs ;

* Hypothèse de test :
H0 : les variables sont indépendantes
H1 : les variables sont dépendantes ;

PROC ANOVA DATA=folderTP.temps;
   TITLE 'Procédure ANOVA';
   CLASS sexe periode;
   MODEL temps = sexe | periode;  *'|' : intéraction des deux;
RUN;

* pvalue < 0.05 
--> Rejet de H0 : le genre et l'âge influent sur le temps passé devant la télé. ;
